# HG changeset patch
# Node ID 685ab63b71af
# Parent  ec8b76f3bf0a
diff --git a/ChangeLog.API b/ChangeLog.API
--- a/ChangeLog.API
+++ b/ChangeLog.API
@@ -355,13 +355,20 @@
 		  Use GLib's GHmac or GChecksum instead.
 		* PURPLE_CMD_FUNC
 		* purple_connection_error_reason
+		* PURPLE_CONNECTION_FLAG_ALLOW_CUSTOM_SMILEY
 		* purple_connection_new
 		* purple_connection_new_unregister
 		* purple_connection_destroy
 		* purple_connection_set_account
 		* purple_contact_set_alias
 		* purple_conv_chat_set_users
+		* purple_conv_custom_smiley_add
+		* purple_conv_custom_smiley_close
+		* purple_conv_custom_smiley_write
 		* PurpleConversationType
+		* purple_conversation_add_smiley
+		* purple_conversation_get_remote_smileys
+		* purple_conversation_get_smiley
 		* purple_conversations_add. Use purple_conversation_manager_register
 		  instead.
 		* purple_conversations_remove. Use
@@ -520,6 +527,24 @@
 		  purple_roomlist_set_protocol_data
 		* PurpleSetPublicAliasFailureCallback
 		* PurpleSetPublicAliasSuccessCallback
+		* purple_smiley_get_type
+		* purple_smiley_new
+		* purple_smiley_new_from_file
+		* purple_smiley_delete
+		* purple_smiley_set_shortcut
+		* purple_smiley_set_data
+		* purple_smiley_get_shortcut
+		* purple_smiley_get_checksum
+		* purple_smiley_get_stored_image
+		* purple_smiley_get_data
+		* purple_smiley_get_extension
+		* purple_smiley_get_full_path
+		* purple_smileys_get_all
+		* purple_smileys_find_by_shortcut
+		* purple_smileys_find_by_checksum
+		* purple_smileys_get_storing_dir
+		* purple_smileys_init
+		* purple_smileys_uninit
 		* purple_socket_get_family
 		* purple_socket_speaks_ipv4
 		* PurpleSoundUiOps
@@ -692,9 +717,6 @@
 		  removed the accel related parameters.
 		* pidgin_setup_screenname_autocomplete now takes a filter function and
 		  its data as final two arguments
-		* smiley_list renamed to PidginSmileyList
-		* smiley_parse_markup renamed to pidgin_smiley_parse_markup
-		* smiley_theme renamed to PidginSmileyTheme
 		* PidginWindow renamed to PidginConvWindow
 
 		Removed:
@@ -785,6 +807,17 @@
 		* pidgin_set_sensitive_if_input
 		* pidgin_set_urgent, use gtk_window_set_urgency_hint instead.
 		* pidgin_setup_screenname_autocomplete_with_filter
+		* PidginSmiley
+		* pidgin_smiley_add_to_list
+		* pidgin_smiley_del_from_list
+		* pidgin_smiley_manager_show
+		* pidgin_smiley_edit
+		* pidgin_smiley_editor_set_shortcut
+		* pidgin_smiley_editor_set_image
+		* pidgin_smiley_editor_set_data
+		* pidgin_smileys_init
+		* pidgin_smileys_uninit
+		* pidgin_smileys_get_all
 		* pidgin_sound_get_event_label
 		* pidgin_sound_get_event_option
 		* pidgin_sound_get_handle
@@ -797,6 +830,7 @@
 		* pidgin_status_box_set_buddy_icon
 		* pidgin_status_box_set_network_available
 		* pidgin_stock_id_from_presence
+		* PIDGIN_STOCK_TOOLBAR_SMILEY
 		* pidgin_text_combo_box_entry_set_text
 		* pidgin_theme_font_free
 		* pidgin_theme_font_get_color
@@ -826,6 +860,9 @@
 		* struct _GtkSmileyTree
 		* struct _PidginChatPane
 		* struct _PidginImPane
+		* smiley_list
+		* smiley_parse_markup
+		* smiley_theme
 
 	Finch:
 		Added:
diff --git a/libpurple/connection.h b/libpurple/connection.h
--- a/libpurple/connection.h
+++ b/libpurple/connection.h
@@ -81,8 +81,6 @@
  *                                     with links
  * @PURPLE_CONNECTION_FLAG_NO_IMAGES: Connection does not support sending of
  *                                    images
- * @PURPLE_CONNECTION_FLAG_ALLOW_CUSTOM_SMILEY: Connection supports sending
- *                                              and receiving custom smileys
  * @PURPLE_CONNECTION_FLAG_SUPPORT_MOODS: Connection supports setting moods
  * @PURPLE_CONNECTION_FLAG_SUPPORT_MOOD_MESSAGES: Connection supports setting
  *                                                a message on moods
@@ -99,7 +97,6 @@
 	PURPLE_CONNECTION_FLAG_NO_FONTSIZE = 0x0020,
 	PURPLE_CONNECTION_FLAG_NO_URLDESC = 0x0040,
 	PURPLE_CONNECTION_FLAG_NO_IMAGES = 0x0080,
-	PURPLE_CONNECTION_FLAG_ALLOW_CUSTOM_SMILEY = 0x0100,
 	PURPLE_CONNECTION_FLAG_SUPPORT_MOODS = 0x0200,
 	PURPLE_CONNECTION_FLAG_SUPPORT_MOOD_MESSAGES = 0x0400
 } PurpleConnectionFlags;
diff --git a/libpurple/core.c b/libpurple/core.c
--- a/libpurple/core.c
+++ b/libpurple/core.c
@@ -40,9 +40,6 @@
 #include "purpleprivate.h"
 #include "savedstatuses.h"
 #include "signals.h"
-#include "smiley-custom.h"
-#include "smiley-parser.h"
-#include "smiley-theme.h"
 #include "status.h"
 #include "stun.h"
 #include "theme-manager.h"
@@ -180,8 +177,6 @@
 	purple_stun_init();
 	purple_xfers_init();
 	purple_idle_init();
-	_purple_smiley_custom_init();
-	_purple_smiley_parser_init();
 
 	/*
 	 * Call this early on to try to auto-detect our IP address and
@@ -223,9 +218,6 @@
 	purple_connections_disconnect_all();
 
 	/* Save .xml files, remove signals, etc. */
-	_purple_smiley_theme_uninit();
-	_purple_smiley_custom_uninit();
-	_purple_smiley_parser_uninit();
 	purple_idle_uninit();
 	purple_conversation_manager_shutdown();
 	purple_conversations_uninit();
@@ -371,14 +363,12 @@
 	xdg_dir_exists = g_file_test(purple_data_dir(), G_FILE_TEST_EXISTS);
 	if (!xdg_dir_exists) {
 		MIGRATE_TO_XDG_DIR(purple_data_dir(), "certificates");
-		MIGRATE_TO_XDG_DIR(purple_data_dir(), "custom_smiley");
 		MIGRATE_TO_XDG_DIR(purple_data_dir(), "logs");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "accounts.xml");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "blist.xml");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "fs-codec.conf");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "fs-element.conf");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "prefs.xml");
-		MIGRATE_TO_XDG_DIR(purple_config_dir(), "smileys.xml");
 		MIGRATE_TO_XDG_DIR(purple_config_dir(), "status.xml");
 	}
 
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -81,11 +81,6 @@
 	'savedstatuses.c',
 	'server.c',
 	'signals.c',
-	'smiley-custom.c',
-	'smiley-list.c',
-	'smiley-parser.c',
-	'smiley-theme.c',
-	'smiley.c',
 	'status.c',
 	'stun.c',
 	'theme.c',
@@ -178,11 +173,6 @@
 	'savedstatuses.h',
 	'server.h',
 	'signals.h',
-	'smiley-custom.h',
-	'smiley-list.h',
-	'smiley-parser.h',
-	'smiley-theme.h',
-	'smiley.h',
 	'status.h',
 	'stun.h',
 	'tests.h',
diff --git a/libpurple/protocols/jabber/jabber.c b/libpurple/protocols/jabber/jabber.c
--- a/libpurple/protocols/jabber/jabber.c
+++ b/libpurple/protocols/jabber/jabber.c
@@ -1076,7 +1076,6 @@
 	PurpleImage *image;
 
 	purple_connection_set_flags(gc, PURPLE_CONNECTION_FLAG_HTML |
-		PURPLE_CONNECTION_FLAG_ALLOW_CUSTOM_SMILEY |
 		PURPLE_CONNECTION_FLAG_NO_IMAGES);
 	js = jabber_stream_new(account);
 	if (js == NULL)
diff --git a/libpurple/protocols/jabber/message.h b/libpurple/protocols/jabber/message.h
--- a/libpurple/protocols/jabber/message.h
+++ b/libpurple/protocols/jabber/message.h
@@ -79,6 +79,4 @@
 
 gboolean jabber_buzz_isenabled(JabberStream *js, const gchar *namespace);
 
-gboolean jabber_custom_smileys_isenabled(JabberStream *js, const gchar *namespace);
-
 #endif /* PURPLE_JABBER_MESSAGE_H */
diff --git a/libpurple/protocols/jabber/message.c b/libpurple/protocols/jabber/message.c
--- a/libpurple/protocols/jabber/message.c
+++ b/libpurple/protocols/jabber/message.c
@@ -34,11 +34,6 @@
 
 #include <string.h>
 
-typedef struct {
-	PurpleConversation *conv;
-	gchar *shortcut;
-} JabberMessageRemoteSmileyAddData;
-
 static GString *jm_body_with_oob(JabberMessage *jm) {
 	GList *etc;
 	GString *body = g_string_new("");
@@ -339,70 +334,6 @@
 	purple_protocol_got_attention(jm->js->gc, jm->from, 0);
 }
 
-static void
-jabber_message_get_refs_from_xmlnode_internal(const PurpleXmlNode *message,
-	GHashTable *table)
-{
-	PurpleXmlNode *child;
-
-	for (child = purple_xmlnode_get_child(message, "img") ; child ;
-		 child = purple_xmlnode_get_next_twin(child)) {
-		const gchar *src = purple_xmlnode_get_attrib(child, "src");
-
-		if (g_str_has_prefix(src, "cid:")) {
-			const gchar *cid = src + 4;
-
-			/* if we haven't "fetched" this yet... */
-			if (!g_hash_table_lookup(table, cid)) {
-				gchar *value;
-				const gchar *alt = purple_xmlnode_get_attrib(child, "alt");
-				/* if there is no "alt" string, use the cid...
-				 include the entire src, eg. "cid:.." to avoid linkification */
-				if (alt && alt[0] != '\0') {
-					/* workaround for when "alt" is set to the value of the
-					 CID (which Jabbim seems to do), to avoid it showing up
-						 as an mailto: link */
-					if (purple_email_is_valid(alt)) {
-						value = g_strdup_printf("smiley:%s", alt);
-					} else {
-						value = g_strdup(alt);
-					}
-				} else {
-					value = g_strdup(src);
-				}
-				g_hash_table_insert(table, g_strdup(cid), value);
-			}
-		}
-	}
-
-	for (child = message->child ; child ; child = child->next) {
-		jabber_message_get_refs_from_xmlnode_internal(child, table);
-	}
-}
-
-static gboolean
-jabber_message_get_refs(gpointer key, gpointer value, gpointer user_data)
-{
-	GList **refs = (GList **) user_data;
-	PurpleKeyValuePair *ref = purple_key_value_pair_new_full(key, value, g_free);
-
-	*refs = g_list_append(*refs, ref);
-
-	return TRUE;
-}
-
-static GList *
-jabber_message_get_refs_from_xmlnode(const PurpleXmlNode *message)
-{
-	GList *refs = NULL;
-	GHashTable *unique_refs = g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
-
-	jabber_message_get_refs_from_xmlnode_internal(message, unique_refs);
-	(void)g_hash_table_foreach_remove(unique_refs, jabber_message_get_refs, &refs);
-	g_hash_table_destroy(unique_refs);
-	return refs;
-}
-
 static gchar *
 jabber_message_xml_to_string_strip_img_smileys(PurpleXmlNode *xhtml)
 {
@@ -474,101 +405,6 @@
 	return g_string_free(out, FALSE);
 }
 
-static void
-jabber_message_add_remote_smileys(JabberStream *js, const gchar *who,
-	const PurpleXmlNode *message)
-{
-	PurpleXmlNode *data_tag;
-	for (data_tag = purple_xmlnode_get_child_with_namespace(message, "data", NS_BOB) ;
-		 data_tag ;
-		 data_tag = purple_xmlnode_get_next_twin(data_tag)) {
-		const gchar *cid = purple_xmlnode_get_attrib(data_tag, "cid");
-		const JabberData *data = jabber_data_find_remote_by_cid(js, who, cid);
-
-		if (!data && cid != NULL) {
-			/* we haven't cached this already, let's add it */
-			JabberData *new_data = jabber_data_create_from_xml(data_tag);
-
-			if (new_data) {
-				jabber_data_associate_remote(js, who, new_data);
-			}
-		}
-	}
-}
-
-static void
-jabber_message_remote_smiley_got(JabberData *jdata, gchar *alt, gpointer d) {
-	JabberMessageRemoteSmileyAddData *data = (JabberMessageRemoteSmileyAddData *)d;
-
-	if (jdata) {
-		PurpleSmiley *smiley = NULL;
-
-		purple_debug_info("jabber",
-			"smiley data retrieved successfully");
-
-		smiley = purple_smiley_new_from_data(
-			data->shortcut,
-			jabber_data_get_data(jdata),
-			jabber_data_get_size(jdata)
-		);
-
-		purple_conversation_add_smiley(data->conv, smiley);
-
-		g_object_unref(G_OBJECT(smiley));
-	} else {
-		purple_debug_error("jabber", "failed retrieving smiley data");
-	}
-
-	g_object_unref(G_OBJECT(data->conv));
-	g_free(data->shortcut);
-	g_slice_free(JabberMessageRemoteSmileyAddData, data);
-}
-
-static void
-jabber_message_remote_smiley_add(JabberStream *js, PurpleConversation *conv,
-	const gchar *from, const gchar *shortcut, const gchar *cid)
-{
-	PurpleSmiley *smiley = NULL;
-	const JabberData *jdata = NULL;
-
-	purple_debug_misc("jabber", "about to add remote smiley %s to the conv",
-		shortcut);
-
-	smiley = purple_conversation_get_smiley(conv, shortcut);
-	if(PURPLE_IS_SMILEY(smiley)) {
-		purple_debug_misc("jabber", "smiley was already present");
-		return;
-	}
-
-	/* TODO: cache lookup by "cid" */
-	jdata = jabber_data_find_remote_by_cid(js, from, cid);
-	if (jdata) {
-		purple_debug_info("jabber", "smiley data is already known");
-
-		smiley = purple_smiley_new_from_data(
-			shortcut,
-			jabber_data_get_data(jdata),
-			jabber_data_get_size(jdata)
-		);
-
-		purple_conversation_add_smiley(conv, smiley);
-
-		g_object_unref(G_OBJECT(smiley));
-	} else {
-		JabberMessageRemoteSmileyAddData *data = NULL;
-
-		data = g_slice_new(JabberMessageRemoteSmileyAddData);
-		data->conv = g_object_ref(conv);
-		data->shortcut = g_strdup(shortcut);
-
-		purple_debug_info("jabber", "smiley data is unknown, "
-			"need to request it");
-
-		jabber_data_request(js, cid, from, NULL, FALSE,
-			jabber_message_remote_smiley_got, data);
-	}
-}
-
 void jabber_message_parse(JabberStream *js, PurpleXmlNode *packet)
 {
 	JabberMessage *jm;
@@ -731,52 +567,8 @@
 		} else if(purple_strequal(child->name, "html") && purple_strequal(xmlns, NS_XHTML_IM)) {
 			if(!jm->xhtml && purple_xmlnode_get_child(child, "body")) {
 				char *c;
-
-				PurpleConnection *gc = js->gc;
-				PurpleAccount *account = purple_connection_get_account(gc);
-				PurpleConversation *conv = NULL;
-				GList *smiley_refs = NULL;
 				gchar *reformatted_xhtml;
 
-				if (purple_account_get_bool(account, "custom_smileys", TRUE)) {
-					/* find a list of smileys ("cid" and "alt" text pairs)
-					  occuring in the message */
-					smiley_refs = jabber_message_get_refs_from_xmlnode(child);
-					purple_debug_info("jabber", "found %d smileys\n",
-						g_list_length(smiley_refs));
-
-					if (smiley_refs) {
-						if (jm->type == JABBER_MESSAGE_GROUPCHAT) {
-							JabberID *jid = jabber_id_new(jm->from);
-							JabberChat *chat = NULL;
-
-							if (jid) {
-								chat = jabber_chat_find(js, jid->node, jid->domain);
-								if (chat)
-									conv = PURPLE_CONVERSATION(chat->conv);
-								jabber_id_free(jid);
-							}
-						} else if (jm->type == JABBER_MESSAGE_NORMAL ||
-						           jm->type == JABBER_MESSAGE_CHAT)
-						{
-							PurpleConversationManager *manager;
-
-							manager = purple_conversation_manager_get_default();
-							conv = purple_conversation_manager_find(manager,
-							                                        account,
-							                                        from);
-							if (!conv) {
-								/* we need to create the conversation here */
-								conv = PURPLE_CONVERSATION(
-									purple_im_conversation_new(account, from));
-							}
-						}
-					}
-
-					/* process any newly provided smileys */
-					jabber_message_add_remote_smileys(js, to, packet);
-				}
-
 				purple_xmlnode_strip_prefixes(child);
 
 				/* reformat xhtml so that img tags with a "cid:" src gets
@@ -788,20 +580,6 @@
 
 				jm->xhtml = reformatted_xhtml;
 
-				/* add known custom emoticons to the conversation */
-				/* note: if there were no smileys in the incoming message, or
-				  	if receiving custom smileys is turned off, smiley_refs will
-					be NULL */
-				if (conv) {
-					for (GList *it = smiley_refs; it; it = g_list_next(it)) {
-						PurpleKeyValuePair *ref = it->data;
-
-						jabber_message_remote_smiley_add(js,
-						        conv, from, ref->value, ref->key);
-					}
-				}
-				g_list_free_full(smiley_refs, (GDestroyNotify)purple_key_value_pair_free);
-
 			    /* Convert all newlines to whitespace. Technically, even regular, non-XML HTML is supposed to ignore newlines, but Pidgin has, as convention
 				 * treated \n as a newline for compatibility with other protocols
 				 */
@@ -923,147 +701,6 @@
 	jabber_message_free(jm);
 }
 
-static gboolean
-jabber_conv_support_custom_smileys(JabberStream *js,
-	PurpleConversation *conv, const gchar *who)
-{
-	JabberBuddy *jb;
-	JabberChat *chat;
-
-	if (PURPLE_IS_IM_CONVERSATION(conv)) {
-		jb = jabber_buddy_find(js, who, FALSE);
-		if (jb) {
-			return jabber_buddy_has_capability(jb, NS_BOB);
-		} else {
-			return FALSE;
-		}
-	} else if (PURPLE_IS_CHAT_CONVERSATION(conv)) {
-		chat = jabber_chat_find_by_conv(PURPLE_CHAT_CONVERSATION(conv));
-		if (chat) {
-			/* do not attempt to send custom smileys in a MUC with more than
-			 10 people, to avoid getting too many BoB requests */
-			return jabber_chat_get_num_participants(chat) <= 10 &&
-				jabber_chat_all_participants_have_capability(chat,
-					NS_BOB);
-		} else {
-			return FALSE;
-		}
-	} else {
-		return FALSE;
-	}
-}
-
-static gboolean
-jabber_message_smileyify_cb(GString *out, PurpleSmiley *smiley,
-	PurpleConversation *_empty, gpointer _unused)
-{
-	const gchar *shortcut;
-	const JabberData *data;
-	PurpleXmlNode *smiley_node;
-	gchar *node_xml;
-
-	shortcut = purple_smiley_get_shortcut(smiley);
-	data = jabber_data_find_local_by_alt(shortcut);
-
-	if (!data)
-		return FALSE;
-
-	smiley_node = jabber_data_get_xhtml_im(data, shortcut);
-	node_xml = purple_xmlnode_to_str(smiley_node, NULL);
-
-	g_string_append(out, node_xml);
-
-	purple_xmlnode_free(smiley_node);
-	g_free(node_xml);
-
-	return TRUE;
-}
-
-static char *
-jabber_message_smileyfy_xhtml(JabberMessage *jm, const char *xhtml)
-{
-	PurpleAccount *account = purple_connection_get_account(jm->js->gc);
-	GList *found_smileys, *it, *it_next;
-	PurpleConversation *conv;
-	PurpleConversationManager *manager;
-	gboolean has_too_large_smiley = FALSE;
-	gchar *smileyfied_xhtml = NULL;
-
-	manager = purple_conversation_manager_get_default();
-	conv = purple_conversation_manager_find(manager, account, jm->to);
-
-	if (!jabber_conv_support_custom_smileys(jm->js, conv, jm->to))
-		return NULL;
-
-	found_smileys = purple_smiley_parser_find(
-		purple_smiley_custom_get_list(), xhtml, TRUE);
-	if (!found_smileys)
-		return NULL;
-
-	for (it = found_smileys; it; it = it_next) {
-		PurpleSmiley *smiley = it->data;
-		gboolean valid = TRUE;
-
-		it_next = g_list_next(it);
-
-		if (purple_image_get_data_size(PURPLE_IMAGE(smiley)) > JABBER_DATA_MAX_SIZE) {
-			has_too_large_smiley = TRUE;
-			valid = FALSE;
-			purple_debug_warning("jabber", "Refusing to send "
-				"smiley %s (too large, max is %d)",
-				purple_smiley_get_shortcut(smiley),
-				JABBER_DATA_MAX_SIZE);
-		}
-
-		if (!valid)
-			found_smileys = g_list_delete_link(found_smileys, it);
-	}
-
-	if (has_too_large_smiley) {
-		purple_conversation_write_system_message(conv,
-			_("A custom smiley in the message is too large to send."),
-			PURPLE_MESSAGE_ERROR);
-	}
-
-	if (!found_smileys)
-		return NULL;
-
-	for (it = found_smileys; it; it = g_list_next(it)) {
-		PurpleSmiley *smiley = it->data;
-		const gchar *shortcut = purple_smiley_get_shortcut(smiley);
-		const gchar *mimetype;
-		JabberData *jdata;
-
-		/* the object has been sent before */
-		if (jabber_data_find_local_by_alt(shortcut))
-			continue;
-
-		mimetype = purple_image_get_mimetype(PURPLE_IMAGE(smiley));
-		if (!mimetype) {
-			purple_debug_error("jabber",
-				"unknown mime type for image");
-			continue;
-		}
-
-		jdata = jabber_data_create_from_data(
-			purple_image_get_data(PURPLE_IMAGE(smiley)),
-			purple_image_get_data_size(PURPLE_IMAGE(smiley)),
-			mimetype, FALSE, jm->js);
-
-		purple_debug_info("jabber", "cache local smiley alt=%s, cid=%s",
-			shortcut, jabber_data_get_cid(jdata));
-		jabber_data_associate_local(jdata, shortcut);
-	}
-
-	g_list_free(found_smileys);
-
-	smileyfied_xhtml = purple_smiley_parser_replace(
-		purple_smiley_custom_get_list(), xhtml,
-		jabber_message_smileyify_cb, NULL);
-
-	return smileyfied_xhtml;
-}
-
 void jabber_message_send(JabberMessage *jm)
 {
 	PurpleXmlNode *message, *child;
@@ -1237,12 +874,6 @@
 	purple_markup_html_to_xhtml(tmp, &xhtml, &jm->body);
 	g_free(tmp);
 
-	tmp = jabber_message_smileyfy_xhtml(jm, xhtml);
-	if (tmp) {
-		g_free(xhtml);
-		xhtml = tmp;
-	}
-
 	/*
 	 * For backward compatibility with user expectations or for those not on
 	 * the user's roster, allow sending XHTML-IM markup.
@@ -1289,11 +920,6 @@
 	tmp = purple_utf8_strip_unprintables(purple_message_get_contents(msg));
 	purple_markup_html_to_xhtml(tmp, &xhtml, &jm->body);
 	g_free(tmp);
-	tmp = jabber_message_smileyfy_xhtml(jm, xhtml);
-	if (tmp) {
-		g_free(xhtml);
-		xhtml = tmp;
-	}
 
 	if (chat->xhtml && !jabber_xhtml_plain_equal(xhtml, jm->body))
 		/* Wrap the message in <p/> for greater interoperability justice. */
@@ -1361,10 +987,3 @@
 gboolean jabber_buzz_isenabled(JabberStream *js, const gchar *namespace) {
 	return js->allowBuzz;
 }
-
-gboolean jabber_custom_smileys_isenabled(JabberStream *js, const gchar *namespace)
-{
-	PurpleAccount *account = purple_connection_get_account(js->gc);
-
-	return purple_account_get_bool(account, "custom_smileys", TRUE);
-}
diff --git a/libpurple/protocols/jabber/xmpp.c b/libpurple/protocols/jabber/xmpp.c
--- a/libpurple/protocols/jabber/xmpp.c
+++ b/libpurple/protocols/jabber/xmpp.c
@@ -74,13 +74,6 @@
 	option = purple_account_option_string_new(_("BOSH URL"), "bosh_url", NULL);
 	opts = g_list_append(opts, option);
 
-	/* this should probably be part of global smiley theme settings
-	 * later on
-	 */
-	option = purple_account_option_bool_new(_("Show Custom Smileys"),
-	                                        "custom_smileys", TRUE);
-	opts = g_list_append(opts, option);
-
 	return opts;
 }
 
diff --git a/libpurple/purpleconversation.h b/libpurple/purpleconversation.h
--- a/libpurple/purpleconversation.h
+++ b/libpurple/purpleconversation.h
@@ -140,7 +140,6 @@
 #include "account.h"
 #include "buddyicon.h"
 #include "log.h"
-#include "smiley-list.h"
 
 G_BEGIN_DECLS
 
@@ -446,36 +445,6 @@
 gssize purple_conversation_get_max_message_size(PurpleConversation *conv);
 
 /**
- * purple_conversation_add_smiley:
- * @conv: The conversation that receives new smiley.
- * @smiley: The smiley.
- *
- * Adds a smiley to the list of smileys that belong to this conversation.
- */
-void purple_conversation_add_smiley(PurpleConversation *conv, PurpleSmiley *smiley);
-
-/**
- * purple_conversation_get_smiley:
- * @conv: The conversation.
- * @shortcut: The shortcut.
- *
- * Lookups for the smiley previously added to this conversation.
- *
- * Returns: (transfer none): The smiley, or %NULL if it doesn't exists.
- */
-PurpleSmiley *purple_conversation_get_smiley(PurpleConversation *conv, const gchar *shortcut);
-
-/**
- * purple_conversation_get_remote_smileys:
- * @conv: The conversation.
- *
- * Get all remote smileys previously added to this conversation.
- *
- * Returns: (transfer none): The list of remote smileys.
- */
-PurpleSmileyList *purple_conversation_get_remote_smileys(PurpleConversation *conv);
-
-/**
  * purple_conversation_present_error:
  * @who:     The user this error is about
  * @account: The account this error is on
diff --git a/libpurple/purpleconversation.c b/libpurple/purpleconversation.c
--- a/libpurple/purpleconversation.c
+++ b/libpurple/purpleconversation.c
@@ -38,7 +38,6 @@
 #include "purpleprotocolclient.h"
 #include "request.h"
 #include "signals.h"
-#include "smiley-list.h"
 
 typedef struct {
 	PurpleAccount *account;           /* The user using this conversation. */
@@ -54,11 +53,6 @@
 
 	PurpleConnectionFlags features;   /* The supported features            */
 	GList *message_history; /* Message history, as a GList of PurpleMessages */
-
-	/* The list of remote smileys. This should be per-buddy (PurpleBuddy),
-	 * but we don't have any class for people not on our buddy
-	 * list (PurpleDude?). So, if we have one, we should switch to it. */
-	PurpleSmileyList *remote_smileys;
 } PurpleConversationPrivate;
 
 enum {
@@ -979,60 +973,3 @@
 
 	return purple_protocol_client_get_max_message_size(PURPLE_PROTOCOL_CLIENT(protocol), conv);
 }
-
-void
-purple_conversation_add_smiley(PurpleConversation *conv, PurpleSmiley *smiley) {
-	PurpleConversationPrivate *priv = NULL;
-
-	g_return_if_fail(PURPLE_IS_CONVERSATION(conv));
-	g_return_if_fail(smiley);
-
-	priv = purple_conversation_get_instance_private(conv);
-
-	if(priv->remote_smileys == NULL) {
-		priv->remote_smileys = purple_smiley_list_new();
-		g_object_set(priv->remote_smileys, "drop-failed-remotes", TRUE, NULL);
-	}
-
-	if(purple_smiley_list_get_by_shortcut(
-	   priv->remote_smileys,
-	   purple_smiley_get_shortcut(smiley)))
-	{
-		/* smiley was already added */
-		return;
-	}
-
-	if(!purple_smiley_list_add(priv->remote_smileys, smiley)) {
-		purple_debug_error("conversation", "failed adding remote smiley to "
-		                   "the list");
-	}
-}
-
-PurpleSmiley *
-purple_conversation_get_smiley(PurpleConversation *conv,
-                               const gchar *shortcut)
-{
-	PurpleConversationPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_CONVERSATION(conv), NULL);
-	g_return_val_if_fail(shortcut, NULL);
-
-	priv = purple_conversation_get_instance_private(conv);
-
-	if(priv->remote_smileys == NULL) {
-		return NULL;
-	}
-
-	return purple_smiley_list_get_by_shortcut(priv->remote_smileys, shortcut);
-}
-
-PurpleSmileyList *
-purple_conversation_get_remote_smileys(PurpleConversation *conv) {
-	PurpleConversationPrivate *priv = NULL;
-
-	g_return_val_if_fail(PURPLE_IS_CONVERSATION(conv), NULL);
-
-	priv = purple_conversation_get_instance_private(conv);
-
-	return priv->remote_smileys;
-}
diff --git a/libpurple/tests/meson.build b/libpurple/tests/meson.build
--- a/libpurple/tests/meson.build
+++ b/libpurple/tests/meson.build
@@ -11,8 +11,6 @@
     'protocol_attention',
     'protocol_xfer',
     'queued_output_stream',
-    'smiley',
-    'smiley_list',
     'trie',
     'util',
     'xmlnode'
diff --git a/pidgin/gtkconv.c b/pidgin/gtkconv.c
--- a/pidgin/gtkconv.c
+++ b/pidgin/gtkconv.c
@@ -104,7 +104,6 @@
 	PIDGIN_CONV_MENU			= 1 << 2,
 	PIDGIN_CONV_TAB_ICON			= 1 << 3,
 	PIDGIN_CONV_TOPIC			= 1 << 4,
-	PIDGIN_CONV_SMILEY_THEME		= 1 << 5,
 	PIDGIN_CONV_COLORIZE_TITLE		= 1 << 6,
 }PidginConvFields;
 
@@ -4750,9 +4749,6 @@
 	purple_prefs_add_bool(PIDGIN_PREFS_ROOT "/conversations/send_underline", FALSE);
 	purple_prefs_add_bool(PIDGIN_PREFS_ROOT "/conversations/send_strike", FALSE);
 	purple_prefs_add_bool(PIDGIN_PREFS_ROOT "/conversations/show_incoming_formatting", TRUE);
-	/* TODO: it's about *remote* smileys, not local ones */
-	purple_prefs_add_bool(PIDGIN_PREFS_ROOT "/conversations/resize_custom_smileys", TRUE);
-	purple_prefs_add_int(PIDGIN_PREFS_ROOT "/conversations/custom_smileys_size", 96);
 	purple_prefs_add_int(PIDGIN_PREFS_ROOT "/conversations/minimum_entry_lines", 2);
 
 	purple_prefs_add_bool(PIDGIN_PREFS_ROOT "/conversations/show_formatting_toolbar", TRUE);
diff --git a/pidgin/libpidgin.c b/pidgin/libpidgin.c
--- a/pidgin/libpidgin.c
+++ b/pidgin/libpidgin.c
@@ -45,7 +45,6 @@
 #include "gtkrequest.h"
 #include "gtkroomlist.h"
 #include "gtksavedstatuses.h"
-#include "gtksmiley-theme.h"
 #include "gtkutils.h"
 #include "gtkwhiteboard.h"
 #include "pidginapplication.h"
@@ -197,7 +196,6 @@
 	pidgin_xfers_init();
 	pidgin_roomlist_init();
 	pidgin_log_init();
-	_pidgin_smiley_theme_init();
 	pidgin_medias_init();
 	pidgin_notify_init();
 }
@@ -209,7 +207,6 @@
 	PurpleDebugUi *ui;
 
 	pidgin_notify_uninit();
-	_pidgin_smiley_theme_uninit();
 	pidgin_commands_uninit();
 	pidgin_conversations_uninit();
 	pidgin_status_uninit();
diff --git a/pidgin/meson.build b/pidgin/meson.build
--- a/pidgin/meson.build
+++ b/pidgin/meson.build
@@ -16,8 +16,6 @@
 	'gtkrequest.c',
 	'gtkroomlist.c',
 	'gtksavedstatuses.c',
-	'gtksmiley-manager.c',
-	'gtksmiley-theme.c',
 	'gtkstatus-icon-theme.c',
 	'gtkstatusbox.c',
 	'gtkutils.c',
@@ -85,8 +83,6 @@
 	'gtkrequest.h',
 	'gtkroomlist.h',
 	'gtksavedstatuses.h',
-	'gtksmiley-manager.h',
-	'gtksmiley-theme.h',
 	'gtkstatus-icon-theme.h',
 	'gtkstatusbox.h',
 	'pidginstock.h',
diff --git a/pidgin/pidginapplication.c b/pidgin/pidginapplication.c
--- a/pidgin/pidginapplication.c
+++ b/pidgin/pidginapplication.c
@@ -40,7 +40,6 @@
 #include "gtkdialogs.h"
 #include "gtkprivacy.h"
 #include "gtkroomlist.h"
-#include "gtksmiley-manager.h"
 #include "gtkxfer.h"
 #include "pidginabout.h"
 #include "pidgincore.h"
@@ -190,13 +189,6 @@
 }
 
 static void
-pidgin_application_custom_smiley(GSimpleAction *simple, GVariant *parameter,
-                                 gpointer data)
-{
-	pidgin_smiley_manager_show();
-}
-
-static void
 pidgin_application_debug(GSimpleAction *simple, GVariant *parameter,
                          gpointer data)
 {
@@ -316,9 +308,6 @@
 		.name = "add-group",
 		.activate = pidgin_application_add_group,
 	}, {
-		.name = "custom-smiley",
-		.activate = pidgin_application_custom_smiley,
-	}, {
 		.name = "debug",
 		.activate = pidgin_application_debug,
 	}, {
diff --git a/pidgin/pidginstock.h b/pidgin/pidginstock.h
--- a/pidgin/pidginstock.h
+++ b/pidgin/pidginstock.h
@@ -98,7 +98,6 @@
 #define PIDGIN_STOCK_TOOLBAR_BGCOLOR      "pidgin-bgcolor"
 #define PIDGIN_STOCK_TOOLBAR_BLOCK        "pidgin-block"
 #define PIDGIN_STOCK_TOOLBAR_FGCOLOR      "pidgin-fgcolor"
-#define PIDGIN_STOCK_TOOLBAR_SMILEY       "pidgin-smiley"
 #define PIDGIN_STOCK_TOOLBAR_FONT_FACE	  "pidgin-font-face"
 #define PIDGIN_STOCK_TOOLBAR_TEXT_SMALLER "pidgin-text-smaller"
 #define PIDGIN_STOCK_TOOLBAR_TEXT_LARGER  "pidgin-text-larger"
diff --git a/pidgin/pidginstock.c b/pidgin/pidginstock.c
--- a/pidgin/pidginstock.c
+++ b/pidgin/pidginstock.c
@@ -123,7 +123,6 @@
 	{ PIDGIN_STOCK_TOOLBAR_BGCOLOR,         "actions", "change-bgcolor.png", FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, NULL },
 	{ PIDGIN_STOCK_TOOLBAR_BLOCK,           "emblems", "emblem-blocked.png", FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, NULL },
 	{ PIDGIN_STOCK_TOOLBAR_FGCOLOR,         "actions", "change-fgcolor.png", FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, NULL },
-	{ PIDGIN_STOCK_TOOLBAR_SMILEY,          "actions", "emote-select.png",   FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, NULL },
 	{ PIDGIN_STOCK_TOOLBAR_FONT_FACE,       "actions", "font-face.png",      FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, NULL },
 	{ PIDGIN_STOCK_TOOLBAR_TEXT_SMALLER,    "actions", "font-size-down.png", FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, NULL },
 	{ PIDGIN_STOCK_TOOLBAR_TEXT_LARGER,     "actions", "font-size-up.png",	 FALSE, TRUE,  FALSE, FALSE, FALSE, FALSE, FALSE, NULL },
